#include "MetaBall.h"

MetaBall::MetaBall(int w, int h)
{
    this->width = w;
    this->height = h;
    bmp = create_bitmap(width, height);
}
MetaBall::~MetaBall()
{
    destroy_bitmap(bmp);
    for(it = ball.begin(); it != ball.end(); it++)
        delete *it;
}
void MetaBall::Update()
{
    for(it = ball.begin(); it != ball.end(); it++)
        for(it2 = ball.begin(); it2 != ball.end(); it2++)
            (*it)->Update(*it2);
    for(it = ball.begin(); it != ball.end(); it++)
        (*it)->DoUpdate();
    for (int x = 0; x < width; x++)
        for (int y = 0; y < height; y++)
        {
            double value = 0;
            for(it = ball.begin(); it != ball.end(); it++)
                value += 300000 / ((*it)->Distance(x, y) + 0.00001);
            int c = value > 256 ? 0 : (int)(value);
            putpixel(bmp,x,y,makecol(c % 256, 2 * c % 256, 5 * c % 256));
        }
}
void MetaBall::Draw(BITMAP* dest, int x, int y)
{
    draw_sprite(dest, bmp, x, y);
}

    
Ball::Ball(int x, int y, double dx, double dy)
{
    this->x = x;
    this->y = y;
    this->dx = dx;
    this->dy = dy;
    weight = 0.001;
}
void Ball::Update(Ball* b)
{
    if (b != this)
    {
        dx += (b->x - x) * weight;
        dy += (b->x - y) * weight;
    }
}
void Ball::DoUpdate()
{
    x += dx;
    y += dy;
}
double Ball::Distance(double x, double y)
{
    return QUAD(this->x - x) + QUAD(this->y - y);
}
